// ChaoLoveIceMDBoy's World RPG Mod Main Lua Script for SRB2 2.2.10 (2022)

freeslot("TOL_WORLDRPG", "MT_BLOCKCURSOR", "S_BLOCKCURSOR", "SPR_BCUR")

G_AddGametype({name = "World RPG", identifier = "worldrpg", typeoflevel = TOL_WORLDRPG, rules = GTR_FRIENDLY, intermissiontype = int_none, description = "Chill out in a scripted 3D multi-area world!"})

mobjinfo[MT_BLOCKCURSOR] = {
	doomednum = -1,
	spawnstate = S_BLOCKCURSOR,
	spawnhealth = 1,
	seestate = S_NULL,
	seesound = sfx_None,
	reactiontime = TICRATE,
	attacksound = sfx_None,
	painstate = S_NULL,
	painchance = 0,
	painsound = sfx_None,
	meleestate = S_NULL,
	missilestate = S_NULL,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_None,
	speed = 0,
	radius = 128*FRACUNIT,
	height = 256*FRACUNIT,
	dispoffset = 0,
	mass = 0,
	damage = 0,
	activesound = sfx_None,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY,
	raisestate = S_NULL
}

states[S_BLOCKCURSOR] = {
	sprite = SPR_BCUR,
	frame = FF_FULLBRIGHT|FF_FLOORSPRITE|A,
	tics = 1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

local worldRPGMapNum = M_MapNumber("MAPW1")

local maxNumOfChunksPerWorldArea = 64

local chunkSizeX = 32

local chunkSizeY = 32

local worldAreas = {
	[0] = {
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		},
		{
			{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
			{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
		}
	}
}

local loadedWorldAreaChunks = {}

local wallTextures = {}

local chunkPositions = {}

local isBuildingMode = false

local chunkSaveTime = -TICRATE

local chunkLoadTime = -TICRATE

local chunkLoadInProgress = false

local lastLoadedChunk = -1

local chunkCleanupTime = -TICRATE

local shouldReloadMap = false

local mainFilePrefix = "client/WorldRPG/ChunkData/WRPGA0/WAC_"

local mainFileExtension = ".dat"

local function toggleHomeMenu(player)
	if not player or not player.valid or not player.isreal return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local pl_wrpg = player.worldrpg
		if pl_wrpg.inHomeMenu
			pl_wrpg.inHomeMenu = false
			if player == consoleplayer
				pl_wrpg.currentMenuPage = 0
				pl_wrpg.currentMenuOption = 0
				pl_wrpg.textData = nil
				pl_wrpg.editText = false
				pl_wrpg.oldText = nil
			end
		else
			pl_wrpg.inHomeMenu = true
			if player == consoleplayer
				pl_wrpg.currentMenuPage = 1
				pl_wrpg.currentMenuOption = 1
			end
		end
	end
end

COM_AddCommand("wrpg_toggleHomeMenu", toggleHomeMenu)

local function teleportPlayerToWorldAreaChunkSpawn(player, loadedWorldAreaChunkMapSectionID)
	if not player or not player.valid return end
	if not loadedWorldAreaChunkMapSectionID or type(loadedWorldAreaChunkMapSectionID) != "number" or loadedWorldAreaChunkMapSectionID < 1 or loadedWorldAreaChunkMapSectionID > 8 return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local teleportLocX, teleportLocY, teleportLocZ
		if loadedWorldAreaChunkMapSectionID == 1 or loadedWorldAreaChunkMapSectionID == 5
			teleportLocX = -8976*FRACUNIT
		elseif loadedWorldAreaChunkMapSectionID == 2 or loadedWorldAreaChunkMapSectionID == 6
			teleportLocX = -272*FRACUNIT
		elseif loadedWorldAreaChunkMapSectionID == 3 or loadedWorldAreaChunkMapSectionID == 7
			teleportLocX = 8432*FRACUNIT
		elseif loadedWorldAreaChunkMapSectionID == 4 or loadedWorldAreaChunkMapSectionID == 8
			teleportLocX = 17136*FRACUNIT
		end
		if loadedWorldAreaChunkMapSectionID >= 1 and loadedWorldAreaChunkMapSectionID <= 4
			teleportLocY = 272*FRACUNIT
		elseif loadedWorldAreaChunkMapSectionID >= 5 and loadedWorldAreaChunkMapSectionID <= 8
			teleportLocY = -8432*FRACUNIT
		end
		if teleportLocX != nil and teleportLocY != nil
			local teleportSubsector = R_PointInSubsectorOrNil(teleportLocX, teleportLocY)
			if teleportSubsector
				teleportLocZ = teleportSubsector.sector.floorheight+(8*FRACUNIT)
				if player.mo.x != teleportLocX or player.mo.y != teleportLocY or player.mo.z != teleportLocZ
					P_TeleportMove(player.mo, teleportLocX, teleportLocY, teleportLocZ)
				end
			end
		end
	end
end

local function setupPlayerWorldRPGData(player)
	if not player or not player.valid return end
	player.isreal = true
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and not splitscreen
		if player.worldrpg == nil or type(player.worldrpg) != "table"
			player.worldrpg = {}
		end
		if player.worldrpg.worldArea == nil or type(player.worldrpg.worldArea) != "number"
			player.worldrpg.worldArea = 0
		end
		if player.worldrpg.worldAreaChunk == nil or type(player.worldrpg.worldAreaChunk) != "number"
			player.worldrpg.worldAreaChunk = 1
		end
		if player.worldrpg.chunkPreparationTime == nil or type(player.worldrpg.chunkPreparationTime) != "number"
			player.worldrpg.chunkPreparationTime = 0
		end
		if player.worldrpg.inHomeMenu == nil or type(player.worldrpg.inHomeMenu) != "boolean"
			player.worldrpg.inHomeMenu = false
		end
		if player == consoleplayer
			if player.worldrpg.currentMenuPage == nil or type(player.worldrpg.currentMenuPage) != "number"
				player.worldrpg.currentMenuPage = 0
			end
			if player.worldrpg.currentMenuOption == nil or type(player.worldrpg.currentMenuOption) != "number"
				player.worldrpg.currentMenuOption = 0
			end
			if player.worldrpg.editText == nil or type(player.worldrpg.editText) != "boolean"
				player.worldrpg.editText = false
			end
		end
		if player.worldrpg.allowWorldRPGControls == nil or type(player.worldrpg.allowWorldRPGControls) != "boolean"
			player.worldrpg.allowWorldRPGControls = true
		end
		if isBuildingMode
			if not (player.pflags & PF_GODMODE)
				player.pflags = $|PF_GODMODE
			end
		else
			if player.pflags & PF_GODMODE
				player.pflags = $ &~ PF_GODMODE
			end
		end
		chatprintf(player, "\131NOTICE: \128Please press the score key to toggle World RPG controls as there is a bug in SRB2 involving the KeyDown hook!\n")
		if not player.mo or not player.mo.valid return end
		if player.mo.worldrpg == nil or type(player.mo.worldrpg) != "table"
			player.mo.worldrpg = {}
		end
		if chunkSaveTime < 0 and chunkLoadTime < 0 and player.worldrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0
			teleportPlayerToWorldAreaChunkSpawn(player, player.worldrpg.worldArea*maxNumOfChunksPerWorldArea+player.worldrpg.worldAreaChunk)
		end
	else
		player.worldrpg = nil
	end
end

local function resetPlayerWorldRPGData()
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		loadedWorldAreaChunks = {}
		wallTextures = {}
		for player in players.iterate
			if player and player.valid
				player.worldrpg = nil
				if player.mo and player.mo.valid
					player.mo.worldrpg = nil
				end
				setupPlayerWorldRPGData(player)
			end
		end
	end
end

COM_AddCommand("wrpg_toggleBuildingMode", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local pl_wrpg = player.worldrpg
		if player.isreal and pl_wrpg.chunkPreparationTime >= 0 return end
		if isBuildingMode
			isBuildingMode = false
			print("Building mode now has been disabled!\n")
		else
			isBuildingMode = true
			print("Building mode now has been enabled!\n")
		end
		resetPlayerWorldRPGData()
	end
end, COM_ADMIN)

COM_AddCommand("wrpg_loadMapWorldRPGData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local pl_wrpg = player.worldrpg
		if player.isreal and pl_wrpg.chunkPreparationTime >= 0 return end
		if pl_wrpg.inHomeMenu
			toggleHomeMenu(player)
		end
		chunkLoadTime = 0
		lastLoadedChunk = 0
	end
end, COM_ADMIN)

COM_AddCommand("wrpg_saveMapWorldRPGData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local pl_wrpg = player.worldrpg
		if player.isreal and pl_wrpg.chunkPreparationTime >= 0 return end
		if pl_wrpg.inHomeMenu
			toggleHomeMenu(player)
		end
		chunkSaveTime = 0
	end
end, COM_ADMIN)

COM_AddCommand("wrpg_resetMapWorldRPGData", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local pl_wrpg = player.worldrpg
		if player.isreal and pl_wrpg.chunkPreparationTime >= 0 return end
		worldAreas = {
		[0] = {
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				},
				{
					{{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWSP|WRPGTWSP|16", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0"},
					{"WRPGTWCO|WRPGTWCO|256", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWGR|WRPGTWGR|0", "WRPGTWCO|WRPGTWCO|256"}}
				}
			}
		}
		resetPlayerWorldRPGData()
	end
end, COM_ADMIN)

local homeMenuOptionFuncs = {
	worldRPGHomeMenu = {
		toggleBuildingMode = function(player, key)
			if not player or not player.valid return end
			if player == server or IsPlayerAdmin(player)
				COM_BufInsertText(player, "wrpg_toggleBuildingMode")
			else
				CONS_Printf(player, "\133ERROR: \128You tried to toggle building mode, but you need to either be the host or an admin to toggle building mode!\n")
			end
		end,
		chunkSelectionMenu = function(player, key)
			if not player or not player.valid return end
			local pl_wrpg = player.worldrpg
			pl_wrpg.currentMenuPage = 2
			pl_wrpg.currentMenuOption = 1
		end,
		mapDataMenu = function(player, key)
			if not player or not player.valid return end
			if player == server or IsPlayerAdmin(player)
				local pl_wrpg = player.worldrpg
				pl_wrpg.currentMenuPage = 3
				pl_wrpg.currentMenuOption = 1
			else
				CONS_Printf(player, "\133ERROR: \128You tried to access the map data menu, but you need to either be the host or an admin to access this menu!\n")
			end
		end
	},
	mapDataMenu = {
		loadMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "wrpg_loadMapWorldRPGData")
		end,
		saveMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "wrpg_saveMapWorldRPGData")
		end,
		resetMapData = function(player, key)
			if not player or not player.valid return end
			if player != server and not IsPlayerAdmin(player) return end
			COM_BufInsertText(player, "wrpg_resetMapWorldRPGData")
		end
	},
	blockEditMenu = {
		setFloorTexture = function(player, key)
			if not player or not player.valid return end
			local pl_wrpg = player.worldrpg
			pl_wrpg.editText = true
			pl_wrpg.oldText = pl_wrpg.textData[1]
		end,
		setWallTexture = function(player, key)
			if not player or not player.valid return end
			local pl_wrpg = player.worldrpg
			pl_wrpg.editText = true
			pl_wrpg.oldText = pl_wrpg.textData[2]
		end,
		setFloorHeight = function(player, key)
			if not player or not player.valid return end
			local pl_wrpg = player.worldrpg
			pl_wrpg.editText = true
			pl_wrpg.oldText = pl_wrpg.textData[3]
		end
	}
}

local homeMenuPages = {
	{"World RPG Home Menu", "worldRPGHomeMenu", false, "worldRPGHomeMenu", {{"Toggle building mode", "toggleBuildingMode", 16*FRACUNIT}, {"Chunk selection menu", "chunkSelectionMenu", 20*FRACUNIT}, {"Map data menu", "mapDataMenu", 24*FRACUNIT}}, 0},
	{"Chunk Selection Menu", "chunkSelectionMenu", true, "chunkSelectionMenu"},
	{"Map Data Menu", "mapDataMenu", false, "mapDataMenu", {{"Load map data", "loadMapData", 16*FRACUNIT}, {"Save map data", "saveMapData", 20*FRACUNIT}, {"Reset map data", "resetMapData", 24*FRACUNIT}}, 1},
	{"Block Edit Menu", "blockEditMenu", false, "blockEditMenu", {{"Set floor texture", "setFloorTexture", 16*FRACUNIT}, {"Set wall texture", "setWallTexture", 20*FRACUNIT}, {"Set floor height", "setFloorHeight", 24*FRACUNIT}}, 0}
}

local homeMenuPageFuncs = {
	worldRPGHomeMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
			local pl_wrpg = player.worldrpg
			for k,v in ipairs(homeMenuPages[1][5])
				if k == pl_wrpg.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end,
	chunkSelectionMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
			local pl_wrpg = player.worldrpg
			for i = 1,8
				if i == pl_wrpg.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 16*FRACUNIT+FixedMul(4*FRACUNIT, (i-1)*FRACUNIT), "Test Chunk " + tostring(i), V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 16*FRACUNIT+FixedMul(4*FRACUNIT, (i-1)*FRACUNIT), "Test Chunk " + tostring(i), V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end,
	mapDataMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
			local pl_wrpg = player.worldrpg
			for k,v in ipairs(homeMenuPages[3][5])
				if k == pl_wrpg.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end,
	blockEditMenu = function(drawer, player, screenWidth, screenHeight)
		if not player or not player.valid return end
		if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
			local pl_wrpg = player.worldrpg
			for k,v in ipairs(homeMenuPages[4][5])
				if k == pl_wrpg.currentMenuOption
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_YELLOWMAP|V_ALLOWLOWERCASE, "small-fixed")
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, v[3], v[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "small-fixed")
				end
			end
		end
	end
}

local function changeSelectedHomeMenuPageOption(player, nextOption, limit)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	if not nextOption or type(nextOption) != "number" return end
	if not limit or type(limit) != "number" return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		local pl_wrpg = player.worldrpg
		if pl_wrpg.currentMenuPage and type(pl_wrpg.currentMenuPage) == "number" and homeMenuPages[pl_wrpg.currentMenuPage] and type(homeMenuPages[pl_wrpg.currentMenuPage]) == "table"
			if nextOption == 1
				if pl_wrpg.currentMenuOption == 1
					pl_wrpg.currentMenuOption = limit
				else
					pl_wrpg.currentMenuOption = $-1
				end
			elseif nextOption == 2
				if pl_wrpg.currentMenuOption == limit
					pl_wrpg.currentMenuOption = 1
				else
					pl_wrpg.currentMenuOption = $+1
				end
			end
		end
	end
end

local function cleanupUnusedWorldAreaChunkInMap(worldArea, worldAreaChunk, player)
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and not shouldReloadMap
		/* Make sure there are no players besides the selected player in the chosen chunk if the selected player is valid; otherwise,
		make sure that there are no players at all in the chosen chunk.*/
		for anotherPlayer in players.iterate
			if anotherPlayer and anotherPlayer.valid
				local apl_wrpg = anotherPlayer.worldrpg
				if apl_wrpg.chunkPreparationTime >= 0 return end
				if player and player.valid and anotherPlayer == player continue end
				if apl_wrpg.worldArea == worldArea and apl_wrpg.worldAreaChunk == worldAreaChunk return end
			end
		end
		// Also, make sure the world area chunk is actually loaded before cleaning up!
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == worldArea*maxNumOfChunksPerWorldArea+worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		loadedWorldAreaChunks[sectorTag] = nil
		local chunkCellX, chunkCellY = 1, 1
		local checkedLinedefs = {}
		for sector in sectors.iterate
			if sector and sector.valid and sector.tag and sector.tag == sectorTag
				sector.floorpic = "F_SKY1"
				wallTextures[#sector] = "-"
				sector.floorheight = 0
				sector.special = 8
				//sector.damagetype = SD_INSTAKILL
				for lineNum = 0,#sector.lines
					local line = sector.lines[lineNum]
					if line and not checkedLinedefs[#line]
						if line.backsector
							line.frontside.bottomtexture = 0
							line.backside.bottomtexture = 0
						else
							line.frontside.bottomtexture = 0
						end
						checkedLinedefs[#line] = true
					end
				end
				chunkPositions[#sector] = nil
			end
		end
	end
end

COM_AddCommand("wrpg_switchWorldAreaChunk", function(player, worldArea, worldAreaChunk)
	if not player or not player.valid return end
	if splitscreen return end
	local pl_wrpg = player.worldrpg
	if not worldArea or type(worldArea) != "string" return end
	if not worldAreaChunk or type(worldAreaChunk) != "string" return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not player.isreal or pl_wrpg.chunkPreparationTime >= 0 return end
		local newWorldArea = tonumber(worldArea)
		local newWorldAreaChunk = tonumber(worldAreaChunk)
		if newWorldArea == nil or type(newWorldArea) != "number" return end
		if newWorldAreaChunk == nil or type(newWorldAreaChunk) != "number" return end
		if worldAreas[newWorldArea] and type(worldAreas[newWorldArea]) == "table" and worldAreas[newWorldArea][newWorldAreaChunk] and type(worldAreas[newWorldArea][newWorldAreaChunk]) == "table"
			if pl_wrpg.worldArea == newWorldArea and pl_wrpg.worldAreaChunk == newWorldAreaChunk CONS_Printf(player, "\133ERROR: \128You tried to switch world area chunks, but the world area chunk that you tried to switch to is already the current world area chunk!\n") return end
			if pl_wrpg.inHomeMenu
				toggleHomeMenu(player)
			end
			cleanupUnusedWorldAreaChunkInMap(pl_wrpg.worldArea, pl_wrpg.worldAreaChunk, player)
			pl_wrpg.worldArea = newWorldArea
			pl_wrpg.worldAreaChunk = newWorldAreaChunk
			pl_wrpg.chunkPreparationTime = 0
		else
			CONS_Printf(player, "\133ERROR: \128You tried to switch world area chunks, but the world area chunk that you tried to switch to does not exist!\n")
		end
	end
end)

local homeMenuAbstractPageThinkers = {
	chunkSelectionMenu = function(player, key)
		if not player or not player.valid return end
		local pl_wrpg = player.worldrpg
		if (key and ((key.name == "up arrow" and not key.repeated) or key.name == "hatup")) or (input.joyAxis(JA_MOVE) == -JOYAXISRANGE and not pl_wrpg.repeatUp)
			changeSelectedHomeMenuPageOption(player, 1, 8)
		elseif (key and ((key.name == "down arrow" and not key.repeated) or key.name == "hatdown")) or (input.joyAxis(JA_MOVE) == JOYAXISRANGE and not pl_wrpg.repeatDown)
			changeSelectedHomeMenuPageOption(player, 2, 8)
		elseif (key and ((key.name == "enter" and not key.repeated) or key.name == "joy1"))
			COM_BufInsertText(player, "wrpg_switchWorldAreaChunk 0 " + tostring(pl_wrpg.currentMenuOption))
		elseif (key and ((key.name == "backspace" and not key.repeated) or key.name == "joy2"))
			pl_wrpg.currentMenuPage = 1
			pl_wrpg.currentMenuOption = 1
		end
	end
}

local function homeMenuNonAbstractPageThinker(player, key)
	if not player or not player.valid return end
	local pl_wrpg = player.worldrpg
	if pl_wrpg.currentMenuPage and type(pl_wrpg.currentMenuPage) == "number" and homeMenuPages[pl_wrpg.currentMenuPage] and type(homeMenuPages[pl_wrpg.currentMenuPage]) == "table"
		local actualMenuPage = homeMenuPages[pl_wrpg.currentMenuPage]
		if pl_wrpg.currentMenuOption and type(pl_wrpg.currentMenuOption) == "number" and not actualMenuPage[3] and actualMenuPage[5] and type(actualMenuPage[5]) == "table"
			// TODO: Make text boxes not exclusive to the 4th home menu page!
			if pl_wrpg.editText and pl_wrpg.currentMenuPage == 4 and pl_wrpg.textData and type(pl_wrpg.textData) == "table" and pl_wrpg.textData[pl_wrpg.currentMenuOption] and type(pl_wrpg.textData[pl_wrpg.currentMenuOption]) == "string"
				if (key and (key.num >= 48 and key.num <= 57 and not key.repeated))
					local maxNewTextLength = 8
					if pl_wrpg.currentMenuOption == 3
						maxNewTextLength = 5
					end
					if string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) < maxNewTextLength
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = table.concat({$, key.name})
					end
				elseif (key and (key.num >= 97 and key.num <= 122 and not key.repeated))
					if pl_wrpg.currentMenuOption != 3 and string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) < 8
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = table.concat({$, string.upper(key.name)})
					end
				elseif (key and (key.name == "-" and not key.repeated))
					if pl_wrpg.currentMenuOption == 3 and string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) == 0
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = table.concat({$, "-"})
					end
				elseif (key and ((key.name == "backspace" and not key.repeated) or key.name == "joy2"))
					if string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) > 0
						local updatedString = string.sub(pl_wrpg.textData[pl_wrpg.currentMenuOption], 1, -2)
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = updatedString
					end
				elseif (key and ((key.name == "enter" and not key.repeated) or key.name == "joy1"))
					if not pl_wrpg.oldText or type(pl_wrpg.oldText) != "string" or string.len(pl_wrpg.oldText) == 0
						pl_wrpg.editText = false
						pl_wrpg.oldText = nil
						return
					end
					local maxOldTextLength, maxNewTextLength = 8, 8
					if pl_wrpg.currentMenuOption == 3
						maxOldTextLength = 5
						maxNewTextLength = 5
					end
					if string.len(pl_wrpg.oldText) > maxOldTextLength
						local updatedString = string.sub(pl_wrpg.oldText, 1, maxOldTextLength)
						pl_wrpg.oldText = updatedString
					end
					if string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) == 0
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = pl_wrpg.oldText
					elseif string.len(pl_wrpg.textData[pl_wrpg.currentMenuOption]) > maxNewTextLength
						local updatedString = string.sub(pl_wrpg.textData[pl_wrpg.currentMenuOption], 1, maxNewTextLength)
						pl_wrpg.textData[pl_wrpg.currentMenuOption] = updatedString
					end
					if pl_wrpg.textData[pl_wrpg.currentMenuOption] != pl_wrpg.oldText
						if pl_wrpg.currentMenuOption == 1
							COM_BufInsertText(player, "wrpg_changeBlockFloorPic " + pl_wrpg.textData[pl_wrpg.currentMenuOption])
						elseif pl_wrpg.currentMenuOption == 2
							COM_BufInsertText(player, "wrpg_changeBlockWallPic " + pl_wrpg.textData[pl_wrpg.currentMenuOption])
						elseif pl_wrpg.currentMenuOption == 3
							COM_BufInsertText(player, "wrpg_changeBlockFloorHeight " + pl_wrpg.textData[pl_wrpg.currentMenuOption])
						end
					end
					pl_wrpg.editText = false
					pl_wrpg.oldText = nil
				end
			else
				if (key and ((key.name == "up arrow" and not key.repeated) or key.name == "hatup")) or (input.joyAxis(JA_MOVE) == -JOYAXISRANGE and not pl_wrpg.repeatUp)
					changeSelectedHomeMenuPageOption(player, 1, #actualMenuPage[5])
				elseif (key and ((key.name == "down arrow" and not key.repeated) or key.name == "hatdown")) or (input.joyAxis(JA_MOVE) == JOYAXISRANGE and not pl_wrpg.repeatDown)
					changeSelectedHomeMenuPageOption(player, 2, #actualMenuPage[5])
				elseif (key and ((key.name == "enter" and not key.repeated) or key.name == "joy1"))
					if actualMenuPage[5][pl_wrpg.currentMenuOption] and type(actualMenuPage[5][pl_wrpg.currentMenuOption]) == "table"
						local actualMenuOption = actualMenuPage[5][pl_wrpg.currentMenuOption]
						if actualMenuPage[4] and type(actualMenuPage[4]) == "string" and homeMenuOptionFuncs[actualMenuPage[4]] and type(homeMenuOptionFuncs[actualMenuPage[4]]) == "table"
							local actualMenuOptionFuncTable = homeMenuOptionFuncs[actualMenuPage[4]]
							if actualMenuOption[2] and type(actualMenuOption[2]) == "string" and actualMenuOptionFuncTable[actualMenuOption[2]] and type(actualMenuOptionFuncTable[actualMenuOption[2]]) == "function"
								local actualMenuOptionFunc = actualMenuOptionFuncTable[actualMenuOption[2]]
								actualMenuOptionFunc(player, key)
							end
						end
					end
				elseif (key and ((key.name == "backspace" and not key.repeated) or key.name == "joy2"))
					if actualMenuPage[6] and type(actualMenuPage[6]) == "number"
						pl_wrpg.currentMenuPage = actualMenuPage[6]
						pl_wrpg.currentMenuOption = 1
					else
						COM_BufInsertText(player, "wrpg_toggleHomeMenu")
					end
				end
			end
		end
	end
end

addHook("NetVars", function(net)
	worldAreas = net($)
	loadedWorldAreaChunks = net($)
	wallTextures = net($)
	chunkPositions = net($)
	isBuildingMode = net($)
	chunkSaveTime = net($)
	chunkLoadTime = net($)
	chunkLoadInProgress = net($)
	lastLoadedChunk = net($)
	chunkCleanupTime = net($)
	shouldReloadMap = net($)
end)

local function cleanupWorldRPGVariables()
	loadedWorldAreaChunks = {}
	wallTextures = {}
	chunkPositions = {}
	isBuildingMode = false
	chunkSaveTime = -TICRATE
	chunkLoadTime = -TICRATE
	chunkCleanupTime = -TICRATE
	shouldReloadMap = false
end

addHook("MapChange", function(mapnum)
	cleanupWorldRPGVariables()
	for player in players.iterate
		player.worldrpg = nil
	end
end)

addHook("PlayerSpawn", setupPlayerWorldRPGData)

COM_AddCommand("wrpg_toggleAllowWorldRPGControls", function(player)
	if not player or not player.valid or not player.isreal return end
	if splitscreen return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if pl_wrpg.allowWorldRPGControls
			pl_wrpg.allowWorldRPGControls = false
			CONS_Printf(player, "You are now unable to use World RPG controls! Please press the score key to enable World RPG controls!\n")
		else
			pl_wrpg.allowWorldRPGControls = true
			CONS_Printf(player, "You are now able to use World RPG controls again! Please press the score key to disable World RPG controls!\n")
		end
	end
end)

addHook("PreThinkFrame", function()
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		if consoleplayer and consoleplayer.valid and consoleplayer.isreal and consoleplayer.playerstate != PST_LIVE
			local pl_wrpg = consoleplayer.worldrpg
			if pl_wrpg.inHomeMenu
				COM_BufInsertText(consoleplayer, "wrpg_toggleHomeMenu")
			end
		end
	end
end)

local function isSystemKey(key)
	if not key return end
	if key.name == "escape" or key.name == "joy7" or key.name == "joy8" or key.num == input.gameControlToKeyNum(GC_TALKKEY) or key.num == input.gameControlToKeyNum(GC_TEAMKEY) or key.num == input.gameControlToKeyNum(GC_SCORES) or key.num == input.gameControlToKeyNum(GC_CONSOLE) or key.num == input.gameControlToKeyNum(GC_PAUSE) or key.num == input.gameControlToKeyNum(GC_SYSTEMMENU) or key.num == input.gameControlToKeyNum(GC_SCREENSHOT) or key.num == input.gameControlToKeyNum(GC_RECORDGIF) or key.num == input.gameControlToKeyNum(GC_VIEWPOINT)
		return true
	else
		return false
	end
end

local function worldRPGMenuThinkers(player, key)
	local pl_wrpg = player.worldrpg
	if pl_wrpg.currentMenuPage and type(pl_wrpg.currentMenuPage) == "number" and homeMenuPages[pl_wrpg.currentMenuPage] and type(homeMenuPages[pl_wrpg.currentMenuPage]) == "table"
		local actualMenuPage = homeMenuPages[pl_wrpg.currentMenuPage]
		if actualMenuPage[3]
			if actualMenuPage[4] and type(actualMenuPage[4]) == "string" and homeMenuAbstractPageThinkers[actualMenuPage[4]] and type(homeMenuAbstractPageThinkers[actualMenuPage[4]]) == "function"
				local actualMenuPageThinker = homeMenuAbstractPageThinkers[actualMenuPage[4]]
				actualMenuPageThinker(player, key)
			end
		else
			homeMenuNonAbstractPageThinker(player, key)
		end
	end
	if not isSystemKey(key) or (pl_wrpg.editText and input.keyNumPrintable(tostring(key.num)))
		return true
	end
end

local function goToBlockEditMenu(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	local pl_wrpg = player.worldrpg
	local sectorTag = 0
	for i = 1,8
		if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
			sectorTag = i
			break
		end
	end
	if not sectorTag return end
	if player.mo.subsector.sector.tag == sectorTag and chunkPositions[#player.mo.subsector.sector]
		if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
			local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
			local chunkCellX = (chunkPositions[#player.mo.subsector.sector]-1)%chunkSizeX+1
			local chunkCellY = (chunkPositions[#player.mo.subsector.sector]-1)/chunkSizeX+1
			if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table" and currentWorldAreaChunk[1][chunkCellY] and type(currentWorldAreaChunk[1][chunkCellY]) == "table" and currentWorldAreaChunk[1][chunkCellY][chunkCellX] and type(currentWorldAreaChunk[1][chunkCellY][chunkCellX]) == "string"
				local currentWorldAreaChunkMapCell = currentWorldAreaChunk[1][chunkCellY][chunkCellX]
				local fullCellData = string.match(currentWorldAreaChunkMapCell, "%w+|%w+|[-]?%d+")
				if not fullCellData or type(fullCellData) != "string"
					return
				end
			else
				return
			end
		else
			return
		end
	end
	pl_wrpg.inHomeMenu = true
	pl_wrpg.currentMenuPage = 4
	pl_wrpg.currentMenuOption = 1
	pl_wrpg.textData = {player.mo.subsector.sector.floorpic, wallTextures[#player.mo.subsector.sector], tostring(FixedInt(player.mo.subsector.sector.floorheight))}
end

local function worldRPGBuildingModeThinkers(player, key)
	local pl_wrpg = player.worldrpg
	if (key and (key.num == input.gameControlToKeyNum(GC_FORWARD) or key.name == "hatup")) or (input.joyAxis(JA_MOVE) == -JOYAXISRANGE and not pl_wrpg.repeatUp)
		COM_BufInsertText(player, "wrpg_moveBuilder 1")
	elseif (key and (key.num == input.gameControlToKeyNum(GC_STRAFELEFT) or key.name == "hatleft")) or (input.joyAxis(JA_STRAFE) == -JOYAXISRANGE and not pl_wrpg.repeatLeft)
		COM_BufInsertText(player, "wrpg_moveBuilder 2")
	elseif (key and (key.num == input.gameControlToKeyNum(GC_BACKWARD) or key.name == "hatdown")) or (input.joyAxis(JA_MOVE) == JOYAXISRANGE and not pl_wrpg.repeatDown)
		COM_BufInsertText(player, "wrpg_moveBuilder 3")
	elseif (key and (key.num == input.gameControlToKeyNum(GC_STRAFERIGHT) or key.name == "hatright")) or (input.joyAxis(JA_STRAFE) == JOYAXISRANGE and not pl_wrpg.repeatRight)
		COM_BufInsertText(player, "wrpg_moveBuilder 4")
	elseif (key and (key.name == "del" or key.name == "joy2"))
		COM_BufInsertText(player, "wrpg_toggleBlockExistence")
	elseif (key and (key.name == "enter" or key.name == "joy3"))
		goToBlockEditMenu(player)
	elseif (key and (key.name == "pgup" or key.name == "joy1"))
		if player.mo and player.mo.valid
			COM_BufInsertText(player, "wrpg_changeBlockFloorHeight " + tostring(FixedInt(player.mo.subsector.sector.floorheight)+8))
		end
	elseif (key and (key.name == "pgdn" or key.name == "joy4"))
		if player.mo and player.mo.valid
			COM_BufInsertText(player, "wrpg_changeBlockFloorHeight " + tostring(FixedInt(player.mo.subsector.sector.floorheight)-8))
		end
	end
	if not isSystemKey(key)
		return true
	end
end

addHook("JumpSpecial", function(player)
	if not player or not player.valid or not player.isreal return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		local pl_wrpg = player.worldrpg
		if not pl_wrpg.allowWorldRPGControls or isBuildingMode or pl_wrpg.inHomeMenu or chunkSaveTime >= 0 or chunkLoadTime >= 0 or pl_wrpg.chunkPreparationTime >= 0 or chunkCleanupTime >= 0 or shouldReloadMap
			return true
		end
	end
end)

addHook("SpinSpecial", function(player)
	if not player or not player.valid or not player.isreal return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		local pl_wrpg = player.worldrpg
		if not pl_wrpg.allowWorldRPGControls or isBuildingMode or pl_wrpg.inHomeMenu or chunkSaveTime >= 0 or chunkLoadTime >= 0 or pl_wrpg.chunkPreparationTime >= 0 or chunkCleanupTime >= 0 or shouldReloadMap
			return true
		end
	end
end)

addHook("PlayerCmd", function(player, cmd)
	if not player or not player.valid or not player.isreal return end
	if splitscreen return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not pl_wrpg.allowWorldRPGControls or (isBuildingMode and (input.joyAxis(JA_TURN) or input.joyAxis(JA_MOVE) or input.joyAxis(JA_LOOK) or input.joyAxis(JA_STRAFE) or input.joyAxis(JA_JUMP) or input.joyAxis(JA_SPIN) or input.joyAxis(JA_FIRE) or input.joyAxis(JA_FIRENORMAL)))
			cmd.forwardmove = 0
			cmd.sidemove = 0
			if player.mo and player.mo.valid
				cmd.angleturn = player.mo.angle>>16
			end
			cmd.aiming = player.aiming>>16
			cmd.buttons = 0
		end
		if pl_wrpg.allowWorldRPGControls and (input.joyAxis(JA_TURN) or input.joyAxis(JA_MOVE) or input.joyAxis(JA_LOOK) or input.joyAxis(JA_STRAFE))
			if pl_wrpg.inHomeMenu
				worldRPGMenuThinkers(player, nil)
			else
				if isBuildingMode
					worldRPGBuildingModeThinkers(player, nil)
				end
			end
		end
		if input.joyAxis(JA_MOVE) == -JOYAXISRANGE
			pl_wrpg.repeatUp = true
		else
			pl_wrpg.repeatUp = false
		end
		if input.joyAxis(JA_MOVE) == JOYAXISRANGE
			pl_wrpg.repeatDown = true
		else
			pl_wrpg.repeatDown = false
		end
		if input.joyAxis(JA_STRAFE) == -JOYAXISRANGE
			pl_wrpg.repeatLeft = true
		else
			pl_wrpg.repeatLeft = false
		end
		if input.joyAxis(JA_STRAFE) == JOYAXISRANGE
			pl_wrpg.repeatRight = true
		else
			pl_wrpg.repeatRight = false
		end
	end
end)

COM_AddCommand("wrpg_moveBuilder", function(player, direction)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	if splitscreen return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not direction or type(direction) != "string" return end
		local newDirection = tonumber(direction)
		if not newDirection or type(newDirection) != "number" return end
		local newPosX, newPosY = player.mo.x, player.mo.y
		if newDirection == 1
			newPosY = $-(256*FRACUNIT)
		elseif newDirection == 2
			newPosX = $+(256*FRACUNIT)
		elseif newDirection == 3
			newPosY = $+(256*FRACUNIT)
		elseif newDirection == 4
			newPosX = $-(256*FRACUNIT)
		else return end
		P_TeleportMove(player.mo, player.mo.x, player.mo.y, player.mo.ceilingz-player.mo.height)
		P_TryMove(player.mo, newPosX, newPosY, true)
		P_TeleportMove(player.mo, player.mo.x, player.mo.y, player.mo.floorz)
	end
end)

local function applyTextureToWalls(player)
	if not player or not player.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		local checkedLinedefs = {}
		for sector in sectors.iterate
			if sector and sector.valid and sector.tag and sector.tag == sectorTag
				for lineNum = 0,#sector.lines
					local line = sector.lines[lineNum]
					if line and not checkedLinedefs[#line]
						if line.backsector and line.frontsector.tag == sectorTag and line.backsector.tag == sectorTag
							if line.frontsector.floorheight == line.backsector.floorheight
								line.frontside.bottomtexture = 0
								line.backside.bottomtexture = 0
							else
								if line.frontsector.floorheight > line.backsector.floorheight
									line.frontside.bottomtexture = 0
									local wallTextureID = R_CheckTextureNumForName(wallTextures[#line.frontsector])
									if wallTextureID == -1 or wallTextures[#line.frontsector] == "-"
										line.backside.bottomtexture = 0
									else
										line.backside.bottomtexture = wallTextureID
									end
								else
									local wallTextureID = R_CheckTextureNumForName(wallTextures[#line.backsector])
									if wallTextureID == -1 or wallTextures[#line.backsector] == "-"
										line.frontside.bottomtexture = 0
									else
										line.frontside.bottomtexture = wallTextureID
									end
									line.backside.bottomtexture  = 0
								end
							end
						else
							line.frontside.bottomtexture = 0
						end
						checkedLinedefs[#line] = true
					end
				end
			end
		end
	end
end

COM_AddCommand("wrpg_toggleBlockExistence", function(player)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		if player.mo.subsector.sector.tag == sectorTag and chunkPositions[#player.mo.subsector.sector]
			if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
				local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
				local chunkCellX = (chunkPositions[#player.mo.subsector.sector]-1)%chunkSizeX+1
				local chunkCellY = (chunkPositions[#player.mo.subsector.sector]-1)/chunkSizeX+1
				if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table" and currentWorldAreaChunk[1][chunkCellY] and type(currentWorldAreaChunk[1][chunkCellY]) == "table" and currentWorldAreaChunk[1][chunkCellY][chunkCellX] and type(currentWorldAreaChunk[1][chunkCellY][chunkCellX]) == "string"
					local currentWorldAreaChunkMapCell = currentWorldAreaChunk[1][chunkCellY][chunkCellX]
					local fullCellData = string.match(currentWorldAreaChunkMapCell, "%w+|%w+|[-]?%d+")
					if fullCellData and type(fullCellData) == "string"
						currentWorldAreaChunk[1][chunkCellY][chunkCellX] = nil
						player.mo.subsector.sector.floorpic = "F_SKY1"
						wallTextures[#player.mo.subsector.sector] = "-"
						player.mo.subsector.sector.floorheight = 0
						player.mo.subsector.sector.special = 7
						//player.mo.subsector.sector.damagetype = SD_DEATHPITNOTILT
					else
						currentWorldAreaChunk[1][chunkCellY][chunkCellX] = "GFZBLOCK|GFZBLOCK|0"
						player.mo.subsector.sector.floorpic = "GFZBLOCK"
						local wallTextureID = R_CheckTextureNumForName("GFZBLOCK")
						if wallTextureID == -1
							wallTextures[#player.mo.subsector.sector] = "-"
						else
							wallTextures[#player.mo.subsector.sector] = "GFZBLOCK"
						end
						player.mo.subsector.sector.floorheight = 0
						player.mo.subsector.sector.special = 0
						//player.mo.subsector.sector.damagetype = SD_NONE
					end
				else
					if not currentWorldAreaChunk[1] or type(currentWorldAreaChunk[1]) != "table" return end
					if not currentWorldAreaChunk[1][chunkCellY] or type(currentWorldAreaChunk[1][chunkCellY]) != "table"
						currentWorldAreaChunk[1][chunkCellY] = {}
					end
					currentWorldAreaChunk[1][chunkCellY][chunkCellX] = "GFZBLOCK|GFZBLOCK|0"
					player.mo.subsector.sector.floorpic = "GFZBLOCK"
					local wallTextureID = R_CheckTextureNumForName("GFZBLOCK")
					if wallTextureID == -1
						wallTextures[#player.mo.subsector.sector] = "-"
					else
						wallTextures[#player.mo.subsector.sector] = "GFZBLOCK"
					end
					player.mo.subsector.sector.floorheight = 0
					player.mo.subsector.sector.special = 0
					//player.mo.subsector.sector.damagetype = SD_NONE
				end
			end
		end
		applyTextureToWalls(player)
	end
end)

COM_AddCommand("wrpg_changeBlockFloorPic", function(player, value)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not value or type(value) != "string" return end
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		if player.mo.subsector.sector.tag == sectorTag and chunkPositions[#player.mo.subsector.sector]
			if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
				local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
				local chunkCellX = (chunkPositions[#player.mo.subsector.sector]-1)%chunkSizeX+1
				local chunkCellY = (chunkPositions[#player.mo.subsector.sector]-1)/chunkSizeX+1
				if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table" and currentWorldAreaChunk[1][chunkCellY] and type(currentWorldAreaChunk[1][chunkCellY]) == "table" and currentWorldAreaChunk[1][chunkCellY][chunkCellX] and type(currentWorldAreaChunk[1][chunkCellY][chunkCellX]) == "string"
					local currentWorldAreaChunkMapCell = currentWorldAreaChunk[1][chunkCellY][chunkCellX]
					local oldFloorPic, wallPic, floorHeight = string.match(currentWorldAreaChunkMapCell, "(%w+)|(%w+)|([-]?%d+)")
					if oldFloorPic != nil and type(oldFloorPic) == "string"
						local newFloorPic = value
						if newFloorPic != nil and type(newFloorPic) == "string"
							if newFloorPic == "" return end
							local newCurrentWorldAreaChunkMapCell = string.gsub(currentWorldAreaChunk[1][chunkCellY][chunkCellX], "%w+|%w+|[-]?%d+", table.concat({newFloorPic, wallPic, floorHeight}, "|"))
							currentWorldAreaChunk[1][chunkCellY][chunkCellX] = newCurrentWorldAreaChunkMapCell
							player.mo.subsector.sector.floorpic = newFloorPic
						else
							return
						end
					else
						return
					end
				else
					return
				end
			else
				return
			end
		end
		applyTextureToWalls(player)
	end
end)

COM_AddCommand("wrpg_changeBlockWallPic", function(player, value)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not value or type(value) != "string" return end
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		if player.mo.subsector.sector.tag == sectorTag and chunkPositions[#player.mo.subsector.sector]
			if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
				local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
				local chunkCellX = (chunkPositions[#player.mo.subsector.sector]-1)%chunkSizeX+1
				local chunkCellY = (chunkPositions[#player.mo.subsector.sector]-1)/chunkSizeX+1
				if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table" and currentWorldAreaChunk[1][chunkCellY] and type(currentWorldAreaChunk[1][chunkCellY]) == "table" and currentWorldAreaChunk[1][chunkCellY][chunkCellX] and type(currentWorldAreaChunk[1][chunkCellY][chunkCellX]) == "string"
					local currentWorldAreaChunkMapCell = currentWorldAreaChunk[1][chunkCellY][chunkCellX]
					local floorPic, oldWallPic, floorHeight = string.match(currentWorldAreaChunkMapCell, "(%w+)|(%w+)|([-]?%d+)")
					if oldWallPic != nil and type(oldWallPic) == "string"
						local newWallPic = value
						if newWallPic != nil and type(newWallPic) == "string"
							local newCurrentWorldAreaChunkMapCell = string.gsub(currentWorldAreaChunk[1][chunkCellY][chunkCellX], "%w+|%w+|[-]?%d+", table.concat({floorPic, newWallPic, floorHeight}, "|"))
							currentWorldAreaChunk[1][chunkCellY][chunkCellX] = newCurrentWorldAreaChunkMapCell
							local newWallPicAsNum = R_CheckTextureNumForName(newWallPic)
							if newWallPicAsNum != -1
								wallTextures[#player.mo.subsector.sector] = newWallPic
							else
								return
							end
						else
							return
						end
					else
						return
					end
				else
					return
				end
			else
				return
			end
		end
		applyTextureToWalls(player)
	end
end)

COM_AddCommand("wrpg_changeBlockFloorHeight", function(player, value)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and pl_wrpg.chunkPreparationTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if not value or type(value) != "string" return end
		local newValue = tonumber(value)
		if newValue == nil or type(newValue) != "number" return end
		local sectorTag = 0
		for i = 1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		if player.mo.subsector.sector.tag == sectorTag and chunkPositions[#player.mo.subsector.sector]
			if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
				local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
				local chunkCellX = (chunkPositions[#player.mo.subsector.sector]-1)%chunkSizeX+1
				local chunkCellY = (chunkPositions[#player.mo.subsector.sector]-1)/chunkSizeX+1
				if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table" and currentWorldAreaChunk[1][chunkCellY] and type(currentWorldAreaChunk[1][chunkCellY]) == "table" and currentWorldAreaChunk[1][chunkCellY][chunkCellX] and type(currentWorldAreaChunk[1][chunkCellY][chunkCellX]) == "string"
					local currentWorldAreaChunkMapCell = currentWorldAreaChunk[1][chunkCellY][chunkCellX]
					local floorPic, wallPic, oldFloorHeight = string.match(currentWorldAreaChunkMapCell, "(%w+)|(%w+)|([-]?%d+)")
					if oldFloorHeight != nil and type(oldFloorHeight) == "string"
						local newFloorHeight = newValue
						if newFloorHeight != nil and type(newFloorHeight) == "number"
							if newFloorHeight < -1024 or newFloorHeight > 1024 return end
							local newFloorHeightAsString = tostring(newFloorHeight)
							if newFloorHeightAsString != nil and type(newFloorHeightAsString) == "string"
								local newCurrentWorldAreaChunkMapCell = string.gsub(currentWorldAreaChunk[1][chunkCellY][chunkCellX], "%w+|%w+|[-]?%d+", table.concat({floorPic, wallPic, newFloorHeightAsString}, "|"))
								currentWorldAreaChunk[1][chunkCellY][chunkCellX] = newCurrentWorldAreaChunkMapCell
								player.mo.subsector.sector.floorheight = newFloorHeight*FRACUNIT
							else
								return
							end
						else
							return
						end
					else
						return
					end
				else
					return
				end
			else
				return
			end
		end
		applyTextureToWalls(player)
	end
end)

addHook("KeyDown", function(key)
	if not consoleplayer or not consoleplayer.valid or not consoleplayer.isreal return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		local pl_wrpg = consoleplayer.worldrpg
		if chunkSaveTime >= 0 or chunkLoadTime >= 0 or pl_wrpg.chunkPreparationTime >= 0 or chunkCleanupTime >= 0 or shouldReloadMap return true end
		if (key.num == input.gameControlToKeyNum(GC_SCORES) and not key.repeated) or key.name == "joy7"
			COM_BufInsertText(consoleplayer, "wrpg_toggleAllowWorldRPGControls")
			return true
		end
		if pl_wrpg.allowWorldRPGControls and consoleplayer.playerstate == PST_LIVE
			if (key.name == "home" and not key.repeated) or key.name == "joy8"
				COM_BufInsertText(consoleplayer, "wrpg_toggleHomeMenu")
				return true
			end
			local status
			if pl_wrpg.inHomeMenu
				status = worldRPGMenuThinkers(consoleplayer, key)
			else
				if isBuildingMode
					status = worldRPGBuildingModeThinkers(consoleplayer, key)
				end
			end
			return status
		end
	end
end)

local function createWorldAreaChunkInMap(player)
	if not player or not player.valid return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap and pl_wrpg.chunkPreparationTime == 0
		for i =	1,8
			if loadedWorldAreaChunks[i] and type(loadedWorldAreaChunks[i]) == "number" and loadedWorldAreaChunks[i] == pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
				pl_wrpg.chunkPreparationTime = -TICRATE
				applyTextureToWalls(player)
				teleportPlayerToWorldAreaChunkSpawn(player, i)
				return
			end
		end
		local sectorTag = 0
		for i = 1,8
			if not loadedWorldAreaChunks[i] or type(loadedWorldAreaChunks[i]) != "number"
				sectorTag = i
				break
			end
		end
		if not sectorTag return end
		loadedWorldAreaChunks[sectorTag] = pl_wrpg.worldArea*maxNumOfChunksPerWorldArea+pl_wrpg.worldAreaChunk
		local chunkCellX, chunkCellY = 1, 1
		for sector in sectors.iterate
			if sector and sector.valid and sector.tag and sector.tag == sectorTag
				if worldAreas[pl_wrpg.worldArea] and type(worldAreas[pl_wrpg.worldArea]) == "table" and worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk] and type(worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]) == "table"
					local currentWorldAreaChunk = worldAreas[pl_wrpg.worldArea][pl_wrpg.worldAreaChunk]
					if currentWorldAreaChunk[1] and type(currentWorldAreaChunk[1]) == "table"
						local currentWorldAreaChunkMap = currentWorldAreaChunk[1]
						if currentWorldAreaChunkMap[chunkCellY] and type(currentWorldAreaChunkMap[chunkCellY]) == "table" and currentWorldAreaChunkMap[chunkCellY][chunkCellX] and type(currentWorldAreaChunkMap[chunkCellY][chunkCellX]) == "string"
							local currentWorldAreaChunkMapCell = currentWorldAreaChunkMap[chunkCellY][chunkCellX]
							local floorPic, wallPic, floorHeight = string.match(currentWorldAreaChunkMapCell, "(%w+)|(%w+)|([-]?%d+)")
							sector.floorpic = floorPic
							local wallPicID = R_CheckTextureNumForName(wallPic)
							if wallPicID == -1
								wallTextures[#sector] = "-"
							else
								wallTextures[#sector] = wallPic
							end
							floorHeight = tonumber($)
							if floorHeight < -1024
								sector.floorHeight = -1024*FRACUNIT
							elseif floorHeight > 1024
								sector.floorHeight = 1024*FRACUNIT
							else
								sector.floorheight = floorHeight*FRACUNIT
							end
							sector.floorheight = floorHeight*FRACUNIT
							sector.special = 0
							//sector.damagetype = SD_NONE
						else
							sector.floorpic = "F_SKY1"
							wallTextures[#sector] = "-"
							sector.floorheight = 0
							sector.special = 7
							//sector.damagetype = SD_DEATHPITNOTILT
						end
					else
						sector.floorpic = "F_SKY1"
						wallTextures[#sector] = "-"
						sector.special = 7
						//sector.damagetype = SD_DEATHPITNOTILT
					end
				else
					sector.floorpic = "F_SKY1"
					wallTextures[#sector] = "-"
					sector.floorheight = 0
					sector.special = 7
					//sector.damagetype = SD_DEATHPITNOTILT
				end
				chunkPositions[#sector] = (chunkCellY-1)*chunkSizeX+chunkCellX
				chunkCellX = $+1
				if chunkCellX > chunkSizeX
					chunkCellY = $+1
					if chunkCellY > chunkSizeY break end
					chunkCellX = 1
				end
			end
		end
		pl_wrpg.chunkPreparationTime = -TICRATE
		applyTextureToWalls(player)
		teleportPlayerToWorldAreaChunkSpawn(player, sectorTag)
	end
end

addHook("PlayerThink", function(player)
	if not player or not player.valid return end
	if splitscreen return end
	local pl_wrpg = player.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		if pl_wrpg.chunkPreparationTime >= 0
			if pl_wrpg.chunkPreparationTime == 0
				createWorldAreaChunkInMap(player)
			end
			if pl_wrpg.chunkPreparationTime >= 0
				pl_wrpg.chunkPreparationTime = $+1
			end
		end
	end
end)

local function adjustBuildingModePlayerData(player)
	if not player or not player.valid return end
	if not player.mo or not player.mo.valid return end
	player.mo.angle = ANGLE_270
	if not (player.mo.flags2 & MF2_DONTDRAW)
		player.mo.flags2 = $|MF2_DONTDRAW
	end
	local playerPosXInt, playerPosYInt = FixedInt(player.mo.x), FixedInt(player.mo.y)
	local blockCursorPosX, blockCursorPosY = (((playerPosXInt/256)*256)*FRACUNIT)-(128*FRACUNIT), (((playerPosYInt/256)*256)*FRACUNIT)+(256*FRACUNIT)
	local blockCursor = P_SpawnMobj(blockCursorPosX, blockCursorPosY, player.mo.floorz, MT_BLOCKCURSOR)
	if blockCursor and blockCursor.valid
		blockCursor.color = player.mo.color
	end
end

local function make3DTopDownCamera(player)
	if not player or not player.valid return end
	if player == consoleplayer
		camera.aiming = -ANGLE_90+1
		if player.mo and player.mo.valid
			camera.angle = player.mo.angle
			P_TeleportCameraMove(camera, player.mo.x, player.mo.y, player.mo.ceilingz)
		end
	end
end

addHook("ThinkFrame", function()
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime < 0 and not shouldReloadMap
		for player in players.iterate
			local pl_wrpg = player.worldrpg
			if player.isreal and pl_wrpg.chunkPreparationTime < 0
				if isBuildingMode
					adjustBuildingModePlayerData(player)
				end
				make3DTopDownCamera(player)
			end
		end
	end
end)

local function checkForEmptyWorldAreaChunks(worldAreaChunkSectionID)
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkLoadTime < 0 and chunkCleanupTime >= 0 and not shouldReloadMap
		if loadedWorldAreaChunks[worldAreaChunkSectionID] and type(loadedWorldAreaChunks[worldAreaChunkSectionID]) == "number"
			local worldArea, worldAreaChunk = loadedWorldAreaChunks[worldAreaChunkSectionID]/(maxNumOfChunksPerWorldArea+1), loadedWorldAreaChunks[worldAreaChunkSectionID]%(maxNumOfChunksPerWorldArea+1)
			cleanupUnusedWorldAreaChunkInMap(worldArea, worldAreaChunk)
		end
		if chunkCleanupTime >= 7*TICRATE
			chunkCleanupTime = -TICRATE
		end
	end
end

COM_AddCommand("wrpg_sendAnnouncement", function(player, statusCode, ...)
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		local newStatusCode = tonumber(statusCode)
		if newStatusCode == nil or type(newStatusCode) != "number"
			newStatusCode = 0
		end
		if newStatusCode == 0
			print(table.concat({...}, " "))
		elseif newStatusCode == 1
			print("\131NOTICE: \128" + table.concat({...}, " "))
		elseif newStatusCode == 2
			print("\130WARNING: \128" + table.concat({...}, " "))
		elseif newStatusCode == 3
			print("\133ERROR: \128" + table.concat({...}, " "))
		end
	end
end)

local function saveWorldAreaChunkByY(currentFile, currentFileName, worldAreaChunk, worldAreaChunkY)
	if not currentFile return end
	for worldAreaChunkX = 1,chunkSizeX
		if worldAreaChunk[worldAreaChunkY] and type(worldAreaChunk[worldAreaChunkY]) == "table" and worldAreaChunk[worldAreaChunkY][worldAreaChunkX] and type(worldAreaChunk[worldAreaChunkY][worldAreaChunkX]) == "string"
			local worldAreaChunkPos = worldAreaChunk[worldAreaChunkY][worldAreaChunkX]
			if worldAreaChunkX == chunkSizeX
				if worldAreaChunkY < chunkSizeY
					currentFile:write(worldAreaChunkPos + "\n")
				else
					currentFile:write(worldAreaChunkPos)
				end
			else
				currentFile:write(worldAreaChunkPos + ",")
			end
		else
			if worldAreaChunkX == chunkSizeX
				if worldAreaChunkY < chunkSizeY
					currentFile:write("nil\n")
				else
					currentFile:write("nil")
				end
			else
				currentFile:write("nil,")
			end
		end
	end
	if worldAreaChunkY < chunkSizeY
		return saveWorldAreaChunkByY(currentFile, currentFileName, worldAreaChunk, worldAreaChunkY+1)
	else
		COM_BufInsertText(server, "wrpg_sendAnnouncement 0 "+currentFileName+" has been successfully saved!")
	end
end

local function getLastKeyInTable(selectedTable)
	if not selectedTable or type(selectedTable) != "table" return end
	local lastKey
	for k,v in pairs(selectedTable)
		if v != nil
			lastKey = k
		end
	end
	return lastKey
end

local function saveWorldAreaChunks(worldAreaChunkSectionID)
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkLoadTime < 0 and chunkCleanupTime < 0 and chunkSaveTime >= 0 and not shouldReloadMap
		local worldArea, worldAreaChunk = worldAreaChunkSectionID/(maxNumOfChunksPerWorldArea+1), worldAreaChunkSectionID%(maxNumOfChunksPerWorldArea+1)
		if isserver and worldAreas[worldArea] and type(worldAreas[worldArea]) == "table" and worldAreas[worldArea][worldAreaChunk] and type(worldAreas[worldArea][worldAreaChunk]) == "table"
			local fileName = mainFilePrefix+tostring(worldAreaChunkSectionID)+".csv"
			local file = io.openlocal(fileName, "w")
			if file
				local currentWorldAreaChunk = worldAreas[worldArea][worldAreaChunk]
				if not currentWorldAreaChunk[1] or type(currentWorldAreaChunk[1]) != "table"
					currentWorldAreaChunk[1] = {}
				end
				saveWorldAreaChunkByY(file, fileName, currentWorldAreaChunk[1], 1)
			else
				COM_BufInsertText(server, "wrpg_sendAnnouncement 3 "+fileName+" has failed to save!")
			end
		end
		local lastWorldArea = getLastKeyInTable(worldAreas)
		local lastWorldAreaChunk = getLastKeyInTable(worldAreas[lastWorldArea])
		if worldArea == lastWorldArea and worldAreaChunk == lastWorldAreaChunk
			chunkSaveTime = -TICRATE
		end
	end
end

local function loadWorldAreaChunkByY(currentFile, currentLine, worldAreaChunk, worldAreaChunkY)
	if not currentFile or not currentLine return end
	worldAreaChunk[worldAreaChunkY] = {}
	local worldAreaChunkX = 1
	for word in string.gmatch(currentLine, "[^,]+")
		local validWord = string.match(word, "%w+|%w+|[-]?%d+")
		if validWord and word == validWord
			worldAreaChunk[worldAreaChunkY][worldAreaChunkX] = word
		end
		if worldAreaChunkX >= chunkSizeX break end
		worldAreaChunkX = $+1
	end
	if worldAreaChunkY < chunkSizeY
		local nextLine = currentFile:read("*l")
		if nextLine
			return loadWorldAreaChunkByY(currentFile, nextLine, worldAreaChunk, worldAreaChunkY+1)
		end
	end
end

local function prepareToRegenerateWorldAreaChunks()
	loadedWorldAreaChunks = {}
	wallTextures = {}
	chunkPositions = {}
	for player in players.iterate
		if player.isreal
			local pl_wrpg = player.worldrpg
			pl_wrpg.chunkPreparationTime = 0
		end
	end
end

local function loadWorldAreaChunks(worldAreaChunkSectionID)
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and chunkSaveTime < 0 and chunkCleanupTime < 0 and chunkLoadTime >= 0 and not shouldReloadMap and not chunkLoadInProgress
		local worldArea, worldAreaChunk = worldAreaChunkSectionID/(maxNumOfChunksPerWorldArea+1), worldAreaChunkSectionID%(maxNumOfChunksPerWorldArea+1)
		local lastWorldArea = getLastKeyInTable(worldAreas)
		local lastWorldAreaChunk = getLastKeyInTable(worldAreas[lastWorldArea])
		if worldAreas[worldArea] and type(worldAreas[worldArea]) == "table" and worldAreas[worldArea][worldAreaChunk] and type(worldAreas[worldArea][worldAreaChunk]) == "table"
			chunkLoadInProgress = true
			local fileName = mainFilePrefix+tostring(worldAreaChunkSectionID)+".csv"
			io.open(fileName, "r", function(file, filename)
				if not file
					print("\133ERROR: \128"+filename+" has failed to load!")
					if worldArea == lastWorldArea and worldAreaChunk == lastWorldAreaChunk
						chunkLoadTime = -TICRATE
						lastLoadedChunk = -1
						prepareToRegenerateWorldAreaChunks()
					else
						lastLoadedChunk = worldAreaChunkSectionID
					end
					chunkLoadInProgress = false
					return
				end
				local firstLine = file:read("*l")
				if firstLine
					local currentWorldAreaChunk = worldAreas[worldArea][worldAreaChunk]
					currentWorldAreaChunk[1] = {}
					loadWorldAreaChunkByY(file, firstLine, currentWorldAreaChunk[1], 1)
				end
				print(filename+" has been successfully loaded!")
				if worldArea == lastWorldArea and worldAreaChunk == lastWorldAreaChunk
					chunkLoadTime = -TICRATE
					lastLoadedChunk = -1
					prepareToRegenerateWorldAreaChunks()
				else
					lastLoadedChunk = worldAreaChunkSectionID
				end
				chunkLoadInProgress = false
			end)
		else
			if worldArea == lastWorldArea and worldAreaChunk == lastWorldAreaChunk
				chunkLoadTime = -TICRATE
				lastLoadedChunk = -1
				prepareToRegenerateWorldAreaChunks()
			else
				lastLoadedChunk = worldAreaChunkSectionID
			end
		end
	end
end

addHook("PostThinkFrame", function()
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf and not shouldReloadMap
		if chunkSaveTime < 0 and chunkLoadTime < 0
			if chunkCleanupTime >= 0
				for player in players.iterate
					if player and player.valid
						local pl_wrpg = player.worldrpg
						if pl_wrpg.chunkPreparationTime >= 0
							shouldReloadMap = true
							print("\133ERROR: \128A serious exploit with WorldRPG has been detected! Refreshing map...\n")
							COM_BufInsertText(server, "map MAPE1")
							return
						end
					end
				end
				if (chunkCleanupTime % TICRATE) == 0
					checkForEmptyWorldAreaChunks(chunkCleanupTime/TICRATE+1)
				end
				if chunkCleanupTime >= 0
					chunkCleanupTime = $+1
				end
			end
		elseif chunkSaveTime >= 0
			if (chunkSaveTime % TICRATE) == 0
				saveWorldAreaChunks(chunkSaveTime/TICRATE+1)
			end
			if chunkSaveTime >= 0
				chunkSaveTime = $+1
			end
		elseif chunkLoadTime >= 0
			if not chunkLoadInProgress
				loadWorldAreaChunks(lastLoadedChunk+1)
			end
			if chunkLoadTime >= 0
				chunkLoadTime = $+1
			end
		end
	end
end)

addHook("SeenPlayer", function(player, seenplayer)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	if not seenplayer or not seenplayer.valid or not seenplayer.isreal return end
	if not seenplayer.mo or not seenplayer.mo.valid return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		if player.mo.x == seenplayer.mo.x and player.mo.y == seenplayer.mo.y and player.mo.z == seenplayer.mo.z
			return true
		else
			return false
		end
	end
end)

hud.add(function(drawer, player)
	if not player or not player.valid or not player.isreal return end
	if not player.mo or not player.mo.valid return end
	if splitscreen return end
	local screenWidth, screenHeight = (drawer.width()/drawer.dupx())*FRACUNIT, (drawer.height()/drawer.dupy())*FRACUNIT
	local screenWidthInt, screenHeightInt = FixedInt(screenWidth), FixedInt(screenHeight)
	local pl_wrpg, mo_wrpg = player.worldrpg, player.mo.worldrpg
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		if chunkSaveTime >= 0 or chunkLoadTime >= 0 or pl_wrpg.chunkPreparationTime >= 0 or chunkCleanupTime >= 0 or shouldReloadMap
			drawer.drawFill(0, 0, screenWidthInt, screenHeightInt, 254)
			if chunkSaveTime >= 0
				drawer.drawString((FixedDiv(screenWidth, 2*FRACUNIT)-162*FRACUNIT)+FRACUNIT/2, 64*FRACUNIT, "Please Wait! Chunk saving in progress...", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_SKYMAP, "fixed")
			elseif chunkLoadTime >= 0
				drawer.drawString((FixedDiv(screenWidth, 2*FRACUNIT)-162*FRACUNIT)+FRACUNIT/2, 64*FRACUNIT, "Please Wait! Chunk loading in progress...", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_SKYMAP, "fixed")
			elseif pl_wrpg.chunkPreparationTime >= 0
				drawer.drawString((FixedDiv(screenWidth, 2*FRACUNIT)-162*FRACUNIT)+FRACUNIT/2, 64*FRACUNIT, "Please Wait! Chunk preparation in progress...", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_SKYMAP, "fixed")
			elseif chunkCleanupTime >= 0
				drawer.drawString((FixedDiv(screenWidth, 2*FRACUNIT)-162*FRACUNIT)+FRACUNIT/2, 64*FRACUNIT, "Please Wait! Chunk cleanup in progress...", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_SKYMAP, "fixed")
			else
				drawer.drawString((FixedDiv(screenWidth, 2*FRACUNIT)-162*FRACUNIT)+FRACUNIT/2, 64*FRACUNIT, "An exploit has been detected! Resetting map...", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_REDMAP, "fixed")
			end
		else
			if pl_wrpg.inHomeMenu
				drawer.drawFill(0, 0, screenWidthInt, screenHeightInt, 122)
				if pl_wrpg.currentMenuPage and type(pl_wrpg.currentMenuPage) == "number" and homeMenuPages[pl_wrpg.currentMenuPage] and type(homeMenuPages[pl_wrpg.currentMenuPage]) == "table"
					local actualMenuPage = homeMenuPages[pl_wrpg.currentMenuPage]
					if actualMenuPage[1] and type(actualMenuPage[1]) == "string"
						drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 8*FRACUNIT, actualMenuPage[1], V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP, "thin-fixed")
					else
						drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 8*FRACUNIT, "???", V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP, "thin-fixed")
					end
					if actualMenuPage[2] and type(actualMenuPage[2]) == "string" and homeMenuPageFuncs[actualMenuPage[2]] and type(homeMenuPageFuncs[actualMenuPage[2]]) == "function"
						local actualMenuPageFunc = homeMenuPageFuncs[actualMenuPage[2]]
						actualMenuPageFunc(drawer, player, screenWidth, screenHeight)
					end
					if pl_wrpg.editText and pl_wrpg.currentMenuOption and type(pl_wrpg.currentMenuOption) == "number" and pl_wrpg.textData and type(pl_wrpg.textData) == "table" and pl_wrpg.textData[pl_wrpg.currentMenuOption] and type(pl_wrpg.textData[pl_wrpg.currentMenuOption]) == "string"
						drawer.drawFill(16, (screenHeightInt/2)-16, screenWidthInt-32, 56, 159+V_SNAPTOTOP|V_SNAPTOLEFT)
						drawer.drawFill(16, (screenHeightInt/2)-16, screenWidthInt-32, 12, 151+V_SNAPTOTOP|V_SNAPTOLEFT)
						drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-40*FRACUNIT, FixedDiv(screenHeight, 2*FRACUNIT)-14*FRACUNIT, "Edit Text", V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE|V_GRAYMAP, "fixed")
						drawer.drawString(16*FRACUNIT, FixedDiv(screenHeight, 2*FRACUNIT), pl_wrpg.textData[pl_wrpg.currentMenuOption], V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "fixed")
					end
				else
					drawer.drawString(FixedDiv(screenWidth, 2*FRACUNIT)-48*FRACUNIT, 8*FRACUNIT, "Invalid Page", V_SNAPTOTOP|V_SNAPTOLEFT|V_INVERTMAP, "thin-fixed")
				end
			end
		end
	end
end, "game")

addHook("PlayerQuit", function(player, reason)
	if not player or not player.valid or player == server return end
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		if chunkSaveTime >= 0 or chunkLoadTime >= 0 or chunkCleanupTime >= 0
			chunkCleanupTime = 0
		else
			local pl_wrpg = player.worldrpg
			cleanupUnusedWorldAreaChunkInMap(pl_wrpg.worldArea, pl_wrpg.worldAreaChunk, player)
		end
	end
end)

addHook("GameQuit", function(quitting)
	if splitscreen return end
	if gametype == GT_WORLDRPG and gamemap == worldRPGMapNum and not udmf
		cleanupWorldRPGVariables()
	end
end)
